#---------------工具方法--------------#

def searchPodXcconfig(configname)
    xcconfig_file = configname
    unless File.exist?(xcconfig_file)
        return ""
    end
    return xcconfig_file
end

def modifyPodXcconfig(xcconfig_file,modify_value)
    text = File.read(xcconfig_file)
    lines = text.lines
    len = lines.size
    for i in 0..(len -1) do
        line = replace_xcconfig_headersearchpath(lines[i],modify_value)
        lines[i] = line unless line.nil?
    end
    text = lines.join()
    # text += "USE_HEADERMAP = false"
    File.open(xcconfig_file,'w'){|f| f.puts text}
end

def replace_xcconfig_headersearchpath(line,modify_value)
    return nil unless line.include?"HEADER_SEARCH_PATHS"
    line = "#{modify_value}\n"
    return line
end

#-----------修改的入口方法-------------#
def modify_aggregate_target_config(targets)
    #targets为主工程的target
    xcconfig_paths = []
    default_target = ''
    for target_name in targets do
        if target_name.start_with? 'Default'
            default_target = target_name
            next
        end
        if default_target.empty?
            target_name = "Pods-#{target_name}"
        else
            target_name = "Pods-#{default_target}-#{target_name}"
        end
        
        outputpath = 'Pods' + '/Target Support Files'
        outputpath = File.join(outputpath,target_name)
        xcconfig_debug_path = File.join(outputpath,target_name + '.debug.xcconfig')
        xcconfig_release_path = File.join(outputpath,target_name + '.release.xcconfig')
        xcconfig_paths.append(xcconfig_debug_path)
        xcconfig_paths.append(xcconfig_release_path)
    end
    
    for xcconfig_name in xcconfig_paths do
        xcconfig_file = searchPodXcconfig(xcconfig_name)
        public_hmap_path = File.join(Pathname.pwd,"Pods/Headers/headermap"+"/public_hmap.hmap")
        modify_value = "HEADER_SEARCH_PATHS = \"#{public_hmap_path}\""
        modifyPodXcconfig(xcconfig_file,modify_value)
    end
    
end