# require 'cocoapods-hmap/command/hmap'
targets = []
Pod::HooksManager.register('cocoapods-hmap', :pre_install) do |installer|

    # check user_framework is on
    podfile = installer.podfile
    podfile.target_definition_list.each do |target_definition|
        next if target_definition.name == "Pods"
        next if target_definition.name.include? "Tests"
        targets.append(target_definition.name)
        if target_definition.uses_frameworks?
            STDERR.puts "插件暂不支持framework产物，只支持static library产物".red
            exit
        end
    end

    headermap_path = File.join(Pathname.pwd,"Pods/Headers/headermap")
    `rm -rf #{headermap_path}` if Dir.exist?(headermap_path)
    require_relative 'hmapcreate/hmap'
end

Pod::HooksManager.register('cocoapods-hmap', :post_install) do |installer|
    #------------生成public.hmap--------------#
    require_relative 'hmapcreate/public_hmap'
    #------------下面为修改xcconfig中的header_search_path及关闭hmap值为USE_HEADERMAP-----------#
    require_relative 'modifyconfig/modify_config'
    modify_all_target_config(installer)
    
    #-------------修改aggregateconfig------------#
    require_relative 'aggregateconfig/modify_aggregate_config'
    modify_aggregate_target_config(targets)

end
