def readPodFile(podfileLock)
    raise "#{podfileLock} is invalid" unless File.exist?(podfileLock)
    file = open(podfileLock)
    pod_names = []
    begin
        beginPodList = false
        for line in file do
            podline = line.strip()
            if beginPodList == false and podline.start_with? 'SPEC CHECKSUMS'
                beginPodList = true
                next
            end
            if not beginPodList
                next
            end
            if beginPodList and podline.size == 0
                break
            end
            podline = podline.split(':')
            podline = podline[0].gsub('"','')
            if podline.start_with? '!'
                next
            end
            pod_names.append(podline)
        end
    rescue
        raise "读取过程失败"
    ensure
       file.close() 
    end

    return pod_names
end

def searchPodHmapJson(podname)
    outputpath = File.join(Pathname.pwd,"Pods/Headers/headermap")
    unless Dir.exist?(outputpath)
        return ""
    end
    outputpath = File.join(outputpath,podname)
    unless Dir.exist?(outputpath)
        return ""
    end
    jsonpath = File.join(outputpath,"#{podname}_public" + '.json')
    unless File.exist?(jsonpath)
        return ""
    end
    hmap_content = File.read(jsonpath)
    hmap_content = hmap_content.chop.reverse.chop.reverse
    if hmap_content.empty?
        return ""
    else
        return hmap_content
    end
end

def generate_public_hmap_file(hmap_content)
    outputpath = File.join(Pathname.pwd,"Pods/Headers/headermap")
    unless Dir.exist?(outputpath)
        raise "headermap 文件夹不存在"
    end
    hmap_json_file = File.join(outputpath,"public_hmap.json")
    `rm -rf #{hmap_json_file}` unless File.exist?(hmap_json_file)
    File.open(hmap_json_file, 'w'){|file| file.write(hmap_content)}
    hmap_file = File.join(outputpath,"public_hmap.hmap")
    `rm -rf #{hmap_file}` unless File.exist?(hmap_file)
    `hmap convert #{hmap_json_file} #{hmap_file}`

end

#生成大的Public.json以后 可以删除每个target下小的Public.json了
def delete_target_public_json(podname)

    outputpath = File.join(Pathname.pwd,"Pods/Headers/headermap")
    unless Dir.exist?(outputpath)
        return
    end
    outputpath = File.join(outputpath,podname)
    unless Dir.exist?(outputpath)
        return
    end
    jsonpath = File.join(outputpath,"#{podname}_public" + '.json')
    unless File.exist?(jsonpath)
        return
    end
    `rm -rf #{jsonpath}`
end


def collectHmapJson()
    podfilelock = "./Podfile.lock"
    podnames = readPodFile(podfilelock)
    hmap_content = ""
    for podname in podnames do
        hmap_item = searchPodHmapJson(podname)
        # delete_target_public_json(podname)
        if hmap_item.size == 0
            next
        end
        begin
            hmap_content = hmap_content + "#{hmap_item},\n"
        rescue
            raise "json 解析失败"
        end
    end
    hmap_content = hmap_content.chomp.chop
    hmap_content = "{" + "\n #{hmap_content} \n" + "}"
    generate_public_hmap_file(hmap_content)
end

collectHmapJson()