def readPodFile(podfileLock)
    raise "#{podfileLock} is invalid" unless File.exist?(podfileLock)
    file = open(podfileLock)
    pod_names = []
    begin
        beginPodList = false
        for line in file do
            podline = line.strip()
            if beginPodList == false and podline.start_with? 'SPEC CHECKSUMS'
                beginPodList = true
                next
            end
            if not beginPodList
                next
            end
            if beginPodList and podline.size == 0
                break
            end
            podline = podline.split(':')
            podline = podline[0].gsub('"','')
            if podline.start_with? '!'
                next
            end
            pod_names.append(podline)
        end
    rescue
        raise "读取过程失败"
    ensure
       file.close() 
    end

    return pod_names
end

def modifyPodXcconfig(xcconfig_file,modify_value)
    text = File.read(xcconfig_file)
    lines = text.lines
    len = lines.size
    for i in 0..(len -1) do
        line = replace_xcconfig_headersearchpath(lines[i],modify_value)
        lines[i] = line unless line.nil?
    end
    text = lines.join()
    text += "USE_HEADERMAP = NO"
    File.open(xcconfig_file,'w'){|f| f.puts text}
end

def replace_xcconfig_headersearchpath(line,modify_value)
    return nil unless line.start_with? "HEADER_SEARCH_PATHS"
    refine_modify_value = ""
    if line.include?('Folly')
        refine_modify_value = modify_value + " \"$(PODS_ROOT)/Folly\" \"$(PODS_ROOT)/boost-for-react-native\" \"$(PODS_ROOT)/DoubleConversion\" \"$(PODS_ROOT)/glog/glog\""
    else
        refine_modify_value = modify_value
    end
    line = "#{refine_modify_value}\n"
    return line
end

def modify_all_target_config(installer)
    #修改podsproject下的target
    podfilelock = "./Podfile.lock"
    target_names = readPodFile(podfilelock)
    for target_name in target_names do
        target_hmap_path = File.join(Pathname.pwd,"Pods/Headers/headermap"+"/#{target_name}/#{target_name}.hmap")
        public_hmap_path = File.join(Pathname.pwd,"Pods/Headers/headermap"+"/public_hmap.hmap")
        modify_value = "HEADER_SEARCH_PATHS = \"#{target_hmap_path}\" \"#{public_hmap_path}\""

        outputpath = File.join(Pathname.pwd,'Pods' + '/Target Support Files') 
        outputpath = File.join(outputpath,target_name)
        xcconfig_debug_file = File.join(outputpath,target_name + '.xcconfig')
        modifyPodXcconfig(xcconfig_debug_file,modify_value)
    end
end